function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import { extractImports } from "@mintsourcejs/mdxjs-common";
import { visit } from "unist-util-visit";

/**
 * 
 * @param {*} tree 
 * @param {Object} [opts] configuration options.
 *   @param {boolean} [opts.meta] provide code meta data to the component as `data-meta` prop. 
 * @returns {Array} an array of import specifications. 
 */
export function processCodeElements(tree, opts) {
  opts = _objectSpread({}, opts);
  var allImportSpecs = [];

  // visit each `element` looking for `code` elements. For each one found, add the `data-meta` property to
  // expose the MD meta data to the code element. Extract any `import` statements from the code block. Finally,
  // add the `data-scope` property as a CSV, where each value is the local name of the import used in the 
  // code block.
  visit(tree, "element", function (node, index, parent) {
    var _node$data;
    if (node.tagName === "code" && node !== null && node !== void 0 && (_node$data = node.data) !== null && _node$data !== void 0 && _node$data.meta) {
      // this is a little horrible, but for some reason, rehype / remark / mdxjs, whatever is responsible for
      // this, wraps the code tag in a PRE tag and we don't want it. Rather than figuring out what is 
      // responsible and removing it, I figured I'd just change it to a DIV to be cheap...
      if (parent.tagName === "pre") {
        parent.tagName = "div";
      }

      // expose the markdown meta data as the "data-meta" attribute on the "code" node.
      if (opts.meta !== false) {
        node.properties["data-meta"] = node.data.meta;
      }

      // take the body value of the "code" node and extract any imports from the beginning of it
      var bodyText = node.children.reduce(function (result, node) {
        return result + node.value;
      }, "");
      var importSpecs = extractImports(bodyText);
      allImportSpecs.push.apply(allImportSpecs, _toConsumableArray(importSpecs));

      // use the import specifications to generate a CSV value for the named module exports
      // to pass into the "data-scope" attribute on the "code" node.
      var scope = importSpecs.reduce(function (result, importSpec) {
        if (importSpec.namedImports) {
          result.push.apply(result, _toConsumableArray(importSpec.namedImports));
        }
        return result;
      }, []);
      node.properties["data-scope"] = scope.join(",");
    }
  });
  return allImportSpecs;
}
//# sourceMappingURL=processCodeElements.js.map