function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import { mergeImports, renderImport } from "@mintsourcejs/mdxjs-common";
import { processCodeElements } from "./processCodeElements.js";
import { createMdxjsEsmNode, createMdxJsxFlowElement } from "./rehypeUtils.js";

/**
 * Plugin to collect imports from the whole document and stuff them into a provider.
 * 
 * @param {Object} [opts] the configuration options.
 *   @param {boolean} [opts.meta] provide code meta data to the component as `data-meta` prop. 
 */
export function rehypeCodePlugin(opts) {
  opts = _objectSpread({}, opts);
  return function () {
    return function (tree) {
      var _scopeProvider$childr;
      var allImportSpecs = processCodeElements(tree, {
        meta: opts.meta
      });

      // deduplicate imports extracted from ALL code elements.
      var mergedImportSpecs = mergeImports(allImportSpecs);

      // build an array of all the local names of imported things.
      var allIdentifiers = mergedImportSpecs.reduce(function (result, importSpec) {
        importSpec.defaultImport && result.push(importSpec.defaultImport);
        importSpec.namedImports && result.push.apply(result, _toConsumableArray(importSpec.namedImports));
        return result;
      }, []);

      // generate the source code for the import statements from our deduped list.   
      var importSrc = [{
        module: "@mintsourcejs/mdxjs-react",
        namedImports: ["MdxScopeProvider"]
      }].concat(_toConsumableArray(mergedImportSpecs)).map(function (importSpec) {
        return renderImport(importSpec);
      }).join("\n");
      var importsNode = createMdxjsEsmNode(importSrc);

      // parse a scope provider with the array of local identifiers passed as a value property
      var valueSrc = "{".concat(allIdentifiers.join(","), "}");
      var scopeProvider = createMdxJsxFlowElement("<MdxScopeProvider value={".concat(valueSrc, "}></MdxScopeProvider>"));
      var index = tree.children.findIndex(function (node) {
        return node.type !== "mdxjsEsm";
      });
      var body = tree.children.splice(index, tree.children.length, importsNode, scopeProvider);
      (_scopeProvider$childr = scopeProvider.children).push.apply(_scopeProvider$childr, _toConsumableArray(body));
    };
  };
}
//# sourceMappingURL=rehypeCodePlugin.js.map